<script setup lang="ts">
import {ref, defineExpose, watch, nextTick, reactive} from "vue";
import {
  ESignSoftware,
  ESignStrategy,
  TCertificateIdentifier,
  TSignConfig,
  TSignContext,
  type TSignedDocument
} from '@/types';
import BackendRestJsApiProvider from '@/provider/BackendRestJsApiProvider';
import useSignConfigurationFetch from '@/composables/useSignConfigurationFetch';
import BrowserPluginStoreAsync, {
  IBrowserPluginStoreAsync,
  type TCertificatesMap
} from '@/provider/BrowserPlugin/StoreService';
import CadesBrowserPluginAsync from '@/provider/BrowserPlugin/CadesBrowserPluginAsync';
import {useBrowserPluginConnector} from '@/composables/useBrowserPluginConnector';
import useCertificateListFetch from '@/composables/useCertificateStore';
import SignService, {ISignServiceAsync} from '@/provider/BrowserPlugin/SignService';
import {useCreateSignature} from '@/composables/useCreateSignature';
import useCreateSignedDoc from '@/composables/useCreateSignedDoc';

const IS_SSR = typeof window === 'undefined';


// defineProps({
//   actuator: {
//     type: Function,
//     required: true,
//   }
// })

const statusRef = ref<EStatus | null>(null);
const isModalOpenRef = ref(false);
const isSignIframeLoadedRef = ref(false);
const signConfigRef = ref<TSignConfig | null>(null);
const pluginRef = ref<CadesBrowserPluginAsync | null>(null);
const storeServiceRef = ref<IBrowserPluginStoreAsync | null>(null);
const signServiceRef = ref<ISignServiceAsync | null>(null);
const canSignRef = ref(false);
const signCtxRef = ref<TSignContext | null>(null);
const signedDocRef = ref<TSignedDocument | null>(null);

const errorRef = ref<Error | null>(null);
const certificatesRef = ref<TCertificatesMap | null>(null);
const selectedCertificateRef = ref<TCertificateIdentifier | null>(null);
watch(selectedCertificateRef, (val) => {
  canSignRef.value = !!(val && val.length > 0);
  console.log('selected: ', val, canSignRef.value);
})
const isBusyRef = ref<boolean | null>(null);

const onSignButtonClick = async (): Promise<void> => {
  console.log('sign button clicked with certificate ', selectedCertificateRef.value);
  if (!pluginRef.value) {
    throw new Error('Неожиданно нет плагина');
  }
  if (!storeServiceRef.value) {
    throw new Error('Почему то нет storeService');
  }
  signServiceRef.value = new SignService(pluginRef.value, storeServiceRef.value);
  isBusyRef.value = true;
  const {isSigning, signature, createSignature, createSignatureError} = useCreateSignature(signServiceRef.value);
  if (!signCtxRef.value) {
    throw new Error('не контекста, когда он так нужен');
  }
  const {strategy} = signCtxRef.value;
  if (!selectedCertificateRef.value) {
    throw new Error('Почему то нет отпечатка перед подписанием')
  }
  if (strategy?.software === ESignSoftware.CPro) {
    strategy.certificate_identifier = selectedCertificateRef.value;
  }
  await createSignature(signCtxRef.value);
  isBusyRef.value = false;
  if (createSignatureError.value) {
    state.status = EStatus.ERROR;
    console.log(createSignatureError.value);
    state.error = new Error('Не создалось');
    return;
  }
  if (!signature.value) {
    throw new Error('Поч нет подписи?');
  }
  signCtxRef.value.signature = signature.value;
  state.status = EStatus.SIGNED;
  console.log(signCtxRef.value);
}

enum EStatus {
  NEW, BUSY, CERT_SELECT, ERROR, SIGNED, DONE
}

type TCmpState = {
  status: EStatus;
  error?: Error;
  certificates?: TCertificatesMap;
  selectedCertificate?: TCertificateIdentifier;
  doc?: TSignedDocument;
}

const getInitialState = (): TCmpState => ({
  error: undefined,
  certificates: undefined,
  status: EStatus.NEW,
  selectedCertificate: undefined,
  doc: undefined
});
const state = reactive<TCmpState>(getInitialState());
watch(state, (curState: TCmpState) => {
  console.log('state: ', curState);
  if (state.status === EStatus.ERROR) {
    isBusyRef.value = false;
    errorRef.value = curState.error ?? new Error('Cтейт переключен в ошибку, но ее не выставил');
    return;
  } else if (state.status === EStatus.BUSY) {
    isBusyRef.value = true;
    return;
  } else if (state.status === EStatus.CERT_SELECT) {
    isBusyRef.value = false;
    if (!curState.certificates) {
      throw new Error('По какой то причине нет сертификатов в стейте');
    }
    certificatesRef.value = curState.certificates;
    selectedCertificateRef.value = null;
    return;
  } else if (state.status === EStatus.SIGNED) {
    isBusyRef.value = true;
    crateSignedDoc();
  } else if (state.status === EStatus.DONE) {
    isModalOpenRef.value = false;
  }
});

// todo: подумать, как убрать такой вотчер нормально использовать signContext
const createSignature = (opt: any) => {
  console.log('Sloted ', opt);
  isModalOpenRef.value = true;
}
watch(isModalOpenRef, (isOpened: boolean) => {
  console.log("Watcher for modal ", isOpened);
  if (isOpened) {
    nextTick(() => {
      runCertificateSelectProcess();
    });
  } else {
    // TODO: state reset
    // state = getInitialState();
    // todo: отписки, деструкторы?
    isSignIframeLoadedRef.value = false;
    selectedCertificateRef.value = null;
    errorRef.value = null;
    certificatesRef.value = null;
    isBusyRef.value = false;
  }
});

const runCertificateSelectProcess = async (): Promise<void> => {
  errorRef.value = null;
  signConfigRef.value = null;
  isModalOpenRef.value = true;
  console.log('Start creating signature');
  signCtxRef.value = {
    strategy: {
      type: ESignStrategy.Qualified,
      software: ESignSoftware.CPro,
      certificate_identifier: 'ABCDEFGHIJKLMNOPQRS' // FIXME: ну вот его может и не быть перед запросом для получения конфига
    },
    content: {
      type: 'text',
      unsigned_message: 'Проверка подписи'
    }
  }

  // Загрузка конфига
  state.status = EStatus.BUSY;
  const signConfigProvider = new BackendRestJsApiProvider();
  const {
    isSignConfigurationFetching, signConfiguration, fetchSignConfiguration, signConfigurationFetchError
  } = useSignConfigurationFetch(signConfigProvider);
  await fetchSignConfiguration(signCtxRef.value);
  if (signConfigurationFetchError.value) {
    state.status = EStatus.ERROR;
    state.error = signConfigurationFetchError.value;
    // errorRef.value = signConfigurationFetchError.value;
    return;
  }
  signConfigRef.value = signConfiguration.value as TSignConfig; // FIXME одинаковые но нет

  // Подключение плагина CPro
  const {getBrowserPluginFactory, browserPluginFactory, connectBrowserPluginFactoryError} = useBrowserPluginConnector();
  await getBrowserPluginFactory();
  if (connectBrowserPluginFactoryError.value) {
    state.status = EStatus.ERROR;
    state.error = connectBrowserPluginFactoryError.value || new Error('Plugin Connection Error');
    return;
    // fixme: так быть не должно
  } else if (browserPluginFactory.value === null) {
    state.status = EStatus.ERROR;
    state.error = new Error('Plugin Connection Error - no instance provided');
    return;
  }
  pluginRef.value = browserPluginFactory.value;
  storeServiceRef.value = new BrowserPluginStoreAsync(pluginRef.value);
  // Загружаем список сертификатов
  const {certificates, fetchCertificateList, certificatesFetchError} = useCertificateListFetch(storeServiceRef.value);
  await fetchCertificateList();
  if (certificatesFetchError.value) {
    state.status = EStatus.ERROR;
    state.error = certificatesFetchError.value;
    return;
  } else if (!certificates.value) {
    throw new Error('Certificates not found');
  }
  state.status = EStatus.CERT_SELECT;
  state.certificates = certificates.value;

  // Подключение iframe
  // const iframeOptions: TEdsSignWidgetOptions = {
  //   iframeOptions: {
  //     baseUrl: 'https://b2b-center.ru.test/',
  //     elementId: 'iframe-target'
  //   }
  // }
  // console.log('create widget')
  // const signWidget = useEdsSignWidget(iframeOptions);
  // await signWidget.createSignature(signContext, signConfigRef.value);
}

const crateSignedDoc = async (): Promise<void> => {
  state.status = EStatus.BUSY;
  const {signedDoc, createSignedDoc, createSignedDocError} = useCreateSignedDoc(new BackendRestJsApiProvider());
  if (!signCtxRef.value) {
    throw new Error('что то с контекстом при создании документа');
  }
  await createSignedDoc(signCtxRef.value);
  if (createSignedDocError.value) {
    state.status = EStatus.ERROR;
    state.error = createSignedDocError.value;
    return;
  }
  if (!signCtxRef.value.doc) {
    throw new Error('Почему то нет документа');
  }
  signedDocRef.value = signCtxRef.value?.doc;
  state.doc = signCtxRef.value?.doc;
  state.status = EStatus.DONE;
}

// eslint-disable-next-line no-undef
// defineExpose({
//   createSignature,
// });

</script>

<template>
  <!--  <div id="iframe-target">iframe-target</div>-->
  <h6>Документ через backend API</h6>
  <pre>Status: {{ statusRef }} </pre>
  <pre v-if="errorRef">Error: {{ errorRef }}</pre>
  <slot :createSignature="createSignature">slot fallback</slot>
  <CdsModal v-model="isModalOpenRef" scrollable width="auto">
    <div v-if="errorRef">
      <h4>Ошибка</h4>
      <p>{{ errorRef.message || 'Какая то ошибка' }}</p>
      <div class="cds-flex cds-justify-center cds-mt-m">
        <CdsButton appearance="secondary" @click="isModalOpenRef = false">
          Закрыть
        </CdsButton>
      </div>
    </div>

    <div v-if="isBusyRef || state.status === EStatus.BUSY">
      <h4>В процессе</h4>
      <p>Что то происходит</p>
      <div class="cds-flex cds-justify-center cds-mt-m">
        <CdsButton appearance="secondary" @click="isModalOpenRef = false">
          Закрыть
        </CdsButton>
      </div>
    </div>

    <div v-if="certificatesRef && state.status === EStatus.CERT_SELECT" style="max-height: 500px">
      <CdsContainer>
        <CdsContainerItem>
          <h4 class="cds-mb-m">Выбрать сертификат</h4>
          <CdsContainer v-model="selectedCertificateRef" required direction="vertical" appearance="secondary"
                        prepend-icon="administrator">
            <CdsContainerItem
                v-for="certificate in certificatesRef.values()"
                :key="certificate.thumbprint"
                :value="certificate.thumbprint"
                group="radio"
                type="selectable"
                label="Группа контейнеров"
            >
              <h6 class="cds-mt-none cds-mb-xxs">
                {{ certificate.thumbprint }}
              </h6>
              <span class="cds-font-body-size-xs">{{ certificate.serialNumber }}</span>
            </CdsContainerItem>
          </CdsContainer>
        </CdsContainerItem>
      </CdsContainer>
      <CdsContainer class="cds-flex cds-justify-center cds-mt-no">
        <CdsContainerItem>
          <CdsButton appearance="secondary" @click="isModalOpenRef = false">
            Закрыть
          </CdsButton>
          <CdsButton appearance="primary" @click="onSignButtonClick" :disabled="!canSignRef">
            Подписать
          </CdsButton>
        </CdsContainerItem>
      </CdsContainer>
    </div>
    <!--    <h4 class="cds-mb-m">Заголовок</h4>-->
    <!--    <div id="iframe-target">iframe-target</div>-->
  </CdsModal>
  <div v-if="signedDocRef && state.status === EStatus.DONE">{{signedDocRef}}</div>
</template>
